<?php

namespace App\Http\Controllers;

use App\domain\travelport\QueryCombinableFlightOffersAction;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Log;

class FlightOfferSearchController extends Controller
{
    public function index(Request $request, QueryCombinableFlightOffersAction $action): JsonResponse
    {
        try {
            $searchModifiers = [
                "cabinPreference" => $request->input('CabinPreference') ?? null,
                "flightType" => $request->input('flightType') ?? null
            ];

            $combinableOffers = $action->execute(
                $request->input('passengerCriteria'),
                $request->input('searchCriteriaFlight'),
                $searchModifiers
            );

            return response()->json([
                'productOffers' => $combinableOffers,
//                'original_response' => $searchResults
            ]);
        } catch (\Exception $exception) {
            Log::error("FlightOfferSearchController->index : " . $exception->getMessage());
            return response()->json(['error_message' => $exception->getMessage()], Response::HTTP_BAD_REQUEST);
        }
    }
}
