<?php

namespace App\domain\travelport;

use Exception;
use GuzzleHttp\Client;
use GuzzleHttp\Exception\GuzzleException;

class CreateOAuthTokens extends TravelportAPI
{
    private const API_URL = 'https://oauth.pp.travelport.com/oauth/oauth20/token';

    private const CLIENT_ID = 'pp-Zfr5MDgcDCvNbstou1eVOsIncklJzbivF9TGydj6';
    private const CLIENT_SECRET = '709f8510f27a0b16b6b8588b1cf9d586663f69cd34992b5fc2c2ca2169fffe6b';

    private const HEADERS = [
        'Content-Type' => 'application/x-www-form-urlencoded'
    ];

    public function requestOAuthAccessToken(): ?array
    {
        $payload = [
            'grant_type' => 'password',
            'username' => 'TP79296687',
            'password' => 'iqhgCL1B',
            'client_id' => self::CLIENT_ID,
            'client_secret' => self::CLIENT_SECRET,
            'scope' => 'openid',
        ];

        return $this->makeTokenRequest($payload);
    }

    public function refreshOAuthAccessToken(): ?array
    {
        if (!session('refresh_token')) {
            return null;
        }

        $payload = [
            'grant_type' => 'refresh_token',
            'refresh_token' => session('refresh_token'),
            'client_id' => self::CLIENT_ID,
            'client_secret' => self::CLIENT_SECRET,
        ];

        return $this->makeTokenRequest($payload);
    }

    private function makeTokenRequest(array $payload): ?array
    {
        try {
            $response = $this->client->post(self::API_URL, [
                'headers' => self::HEADERS,
                'form_params' => $payload,
            ]);

            $responseData = json_decode($response->getBody(), true);
            $this->storeInSession($responseData);
            return $responseData;
        } catch (Exception|GuzzleException $e) {
            echo 'Error: ' . $e->getMessage();
            return null;
        }
    }

    protected function storeInSession(array $responseData): void
    {
        $expiresInMinutes = intval($responseData["expires_in"]) / 60;

        session([
            'access_token' => $responseData["access_token"],
            'expires_in' => now()->addMinutes($expiresInMinutes)
        ]);

        session([
            'refresh_token' => $responseData["refresh_token"]
        ]);
    }
}
